import subway
import cherrypy
from subway import helpers

def get_superglobal_namespace():
    """
    Namespace of all of Subway's "superglobals"
    """
    return dict([(name, getattr(subway, name)) for name in subway.__all__])

def get_controller_namespace(view_manager, model):
    ns = get_superglobal_namespace()
    
    ns.update({
               "view" : view_manager,
               "model" : model,
               })
    return ns

def get_model_namespace():
    ns = get_superglobal_namespace()
    
    ns.update({
               "SQLModel" : subway.SQLModel,
               })
    try:
        import sqlobject
        for k in dir(sqlobject):
            if not k.startswith("__"):
                ns[k] = getattr(sqlobject, k)
    except ImportError:
        pass
    return ns

def get_daemon_namespace(model):
    ns = get_superglobal_namespace()
    ns["model"] = model
    return ns

#~ DEFAULT_VIEW_NAMESPACE = {
    #~ # used somewhere else (?)      
#~ }

def get_view_namespace():
    ns = get_superglobal_namespace()
    ns["model"] = lambda: subway.model
    
    #ns.update(DEFAULT_VIEW_NAMESPACE)
    
    # add template filters to ns
    #for filter_name in helpers.__all__:
    #    ns[filter_name] = getattr(helpers, filter_name)
    
    return ns
