from subway.framework import test
import subway, sqlobject, sys

class Data(subway.SQLModel):
    data = sqlobject.StringCol()

class Root(test.Controller):
    @subway.expose
    def index(self):
        l = Data.select()
        if not l.count():
            return 'no data'
        else:
            return [row.data for row in l]

    @subway.expose
    def insert(self, data):
        if Data(data=data):
            return 'inserted '+data

class TestDatabase(test.TestCase):
    def setUp(self):
        self.start_app(Root(), config={'subway.sql_connection_uri': 'sqlite:/:memory:'})
        self.load_models()

    def test_model_loading(self):
        self.assertEqual(subway.model.all_models, {'Data': Data})
        
    def test_insert(self):
        self.assertEqual(self.request("/").body, ['no data'])
        self.assertEqual(self.request("/insert/testing").body, ['inserted testing'])
