def copy_tree(skeleton_dir, homedir):
    import os
    import shutil
    import sys
    import stat
    
    for (dirpath, dirnames, filenames) in os.walk(skeleton_dir):
        if ".svn" in dirnames:
            dirnames.remove(".svn")
        basedir = dirpath[len(skeleton_dir)+1:]
        for dirname in dirnames:
            #print "Copying directory %r to %r" % (os.path.join(dirpath, dirname), os.path.join(homedir, basedir, dirname))
            os.mkdir(os.path.join(homedir, basedir, dirname))
        for filename in filenames:
            if filename == "__init__.py":
                if open(os.path.join(dirpath, filename), "r").read(8) == "#@nocopy":
                    continue
            if filename.endswith(".pyc"):
                continue
            dest = os.path.join(homedir, basedir, filename)
            #print "Copying file %r to %r" % (os.path.join(dirpath, filename), dest)
            shutil.copyfile(os.path.join(dirpath, filename), dest)
            if os.path.basename(dirpath) == "scripts":
                try:
                    oldmode = os.stat(dest).st_mode
                    os.chmod(dest, oldmode|stat.S_IXUSR|stat.S_IXGRP)
                except:
                    pass

def create():
    """
    create(): create the Subway app skeleton
    """
    from distutils import sysconfig
    import os
    import sys
    try:
        homedir = sys.argv[1]
    except:
        print "You did not pass a required command-line argument."
        return
    if os.path.exists(homedir):
        print "%s already exists; please remove it to continue." % homedir
        return
    import pkg_resources
    skeleton_dir = pkg_resources.resource_filename("subway", "skeleton")
    os.mkdir(homedir)
    copy_tree(skeleton_dir, homedir)
    print "Your Subway app is now created at %s. Please see the README.txt file in that directory for more information." % homedir
    
